//                                               -*- C++ -*-
/**
 *  @brief The external header file of OpenTURNS for subdir Algorithm
 *
 *  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
 *
 *  This library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef OPENTURNS_OTALGORITHM_HXX
#define OPENTURNS_OTALGORITHM_HXX

#include "openturns/TaylorExpansionMoments.hxx"

#include "openturns/OTAnalytical.hxx"
#include "openturns/OTClassification.hxx"
#include "openturns/OTWeightedExperiments.hxx"
#include "openturns/OTMetaModel.hxx"
#include "openturns/OTOrthogonalBasis.hxx"
#include "openturns/OTSensitivity.hxx"
#include "openturns/OTSimulation.hxx"
#include "openturns/OTTransformation.hxx"
#include "openturns/OTUncertaintyOptimization.hxx"

#endif /* OPENTURNS_OTALGORITHM_HXX */
