//                                               -*- C++ -*-
/**
 *  @brief The external header file of OpenTURNS for subdir Kriging
 *
 *  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
 *
 *  This library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef OPENTURNS_OTKRIGING_HXX
#define OPENTURNS_OTKRIGING_HXX

#include "openturns/KrigingEvaluation.hxx"
#include "openturns/KrigingGradient.hxx"
#include "openturns/KrigingAlgorithm.hxx"
#include "openturns/KrigingResult.hxx"
#include "openturns/GeneralLinearModelResult.hxx"
#include "openturns/GeneralLinearModelAlgorithm.hxx"
#include "openturns/GaussianProcessFitterResult.hxx"
#include "openturns/GaussianProcessFitter.hxx"
#include "openturns/GaussianProcessRegressionResult.hxx"
#include "openturns/GaussianProcessRegression.hxx"
#include "openturns/GaussianProcessConditionalCovariance.hxx"

#endif /* OPENTURNS_OTKRIGING_HXX */
