//                                               -*- C++ -*-
/**
 *  @brief The external header file of OpenTURNS for subdir Sensitivity
 *
 *  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
 *
 *  This library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef OPENTURNS_OTSENSITIVITY_HXX
#define OPENTURNS_OTSENSITIVITY_HXX

#include "openturns/ANCOVA.hxx"
#include "openturns/FAST.hxx"
#include "openturns/SobolIndicesAlgorithmImplementation.hxx"
#include "openturns/SobolIndicesAlgorithm.hxx"
#include "openturns/RankSobolSensitivityAlgorithm.hxx"
#include "openturns/SaltelliSensitivityAlgorithm.hxx"
#include "openturns/MauntzKucherenkoSensitivityAlgorithm.hxx"
#include "openturns/MartinezSensitivityAlgorithm.hxx"
#include "openturns/JansenSensitivityAlgorithm.hxx"
#include "openturns/SobolIndicesExperiment.hxx"
#include "openturns/HSICEstimatorImplementation.hxx"
#include "openturns/HSICEstimator.hxx"
#include "openturns/HSICEstimatorConditionalSensitivity.hxx"
#include "openturns/HSICEstimatorTargetSensitivity.hxx"
#include "openturns/HSICEstimatorGlobalSensitivity.hxx"
#include "openturns/HSICStat.hxx"
#include "openturns/HSICStatImplementation.hxx"
#include "openturns/HSICUStat.hxx"
#include "openturns/HSICVStat.hxx"
#endif /* OPENTURNS_OTSENSITIVITY_HXX */
