%feature("docstring") OT::IndependentCopulaFactory
"Independent Copula factory.


See also
--------
DistributionFactory, IndependentCopula"

// ---------------------------------------------------------------------

%feature("docstring") OT::IndependentCopulaFactory::buildAsIndependentCopula
"Build the independent copula.

**Available usages**:

    buildAsIndependentCopula()

    buildAsIndependentCopula(*sample*)

    buildAsIndependentCopula(*param*)

Parameters
----------
sample : 2-d sequence of float, of dimension :math:`d`
    The sample of size :math:`n>0` from which the copula is estimated.
param : sequence of float
    The dimension of the IndependentCopula.

Returns
-------
copula : :class:`~openturns.IndependentCopula`
    The estimated copula as an independent copula.
"
