%feature("docstring") OT::TrapezoidalFactory
"Trapezoidal factory.

Notes
-----
The parameters are estimated by the maximum likelihood method.

See also
--------
DistributionFactory, Trapezoidal"

// ---------------------------------------------------------------------

%feature("docstring") OT::TrapezoidalFactory::buildAsTrapezoidal
"Estimate the distribution as native distribution.

**Available usages**:

    buildAsTrapezoidal()

    buildAsTrapezoidal(*sample*)

    buildAsTrapezoidal(*param*)

Parameters
----------
sample : 2-d sequence of float
    Data.
param : sequence of float
    The parameters of the :class:`~openturns.Trapezoidal`.

Returns
-------
dist : :class:`~openturns.Trapezoidal`
    The estimated distribution as a Trapezoidal.
    
    In the first usage, the default Trapezoidal distribution is built."
